/*
 * LikelihoodCache.h
 *
 *  Created on: Mar 7, 2012
 *      Author: jeffrp
 */

#ifndef LIKELIHOODCACHE_H_
#define LIKELIHOODCACHE_H_

class LikelihoodCache {
public:
	LikelihoodCache(int seqLength);
	virtual ~LikelihoodCache();

	bool isCached(int i, int j);
	double getCached(int i, int j);
	void setCached(int i, int j, double likelihood);

    bool isCachedShape(int i, int j);
    double getCachedShape(int i, int j);
    void setCachedShape(int i, int j, double likelihood);

	bool isCached(int i);
	double getCached(int i);
	void setCached(int i, double likelihood);

    bool isCachedShape(int i);
    double getCachedShape(int i);
    void setCachedShape(int i, double likelihood);

private:
    double* singleCache;
    double** stackCache;

	double* unpairedCache;
	double** pairedCache;
	//int* index;	triangular matrix
	int length;
};

#endif /* LIKELIHOODCACHE_H_ */