/*
 * Copyright: Nicholas P Wiebe (2008-2009) and Irmtraud M Meyer (2008-2009)
 * License: licensed under the GNU General Public License version 3 (GPLv3)
 * Utilities.h
 */

#define NUM_BASES 4
#define NUM_PAIRS 16


#ifndef UTILITIES_H_
#define UTILITIES_H_

#include <vector>
#include <string>

using namespace std;

class Utilities {

public:

	/**
	 * similar to STL lowerBound, except returns an index instead of an
	 * iterator
	 *
	 */
	static int lowerBound(vector<double> & v, int begin, int end, double value);
    static int lowerBoundShape(vector<double> & v, int begin, int end, double value);

	static void interpret(char a, int* table);
	static void interpretNonPairingGap(int* nongap, int* table);
	/**
	 * Checks if the base pair formed by nucleotides a and b is a
	 * canonical bp (AU, GC, or GU)
	 */
	static bool validBP(char a, char b);

	static void trimSpaces(string& str);

//no constructor... just static methods
private:
	Utilities();
	virtual ~Utilities();

};

#endif /* UTILITIES_H_ */
