/*
  File autogenerated by gengetopt version 2.22.6
  generated with the following command:
  gengetopt 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef FIX_UNUSED
#define FIX_UNUSED(X) (void) (X) /* avoid warnings for unused params */
#endif

#include <getopt.h>

#include "cmdline.h"

const char *gengetopt_args_info_purpose = "A method for detecting the conserved helices of functional RNA structures,\nincluding transient, pseudo-knotted and alternative structures";

const char *gengetopt_args_info_usage = "Usage: ShapeSorter -a <query_file> -t <tree_file> -r <shape_file> [options]";

const char *gengetopt_args_info_versiontext = "";

const char *gengetopt_args_info_description = "Transat reads a set of alignment homologous RNA sequences and returns a list of\ncandidate helices with measures of conservation and significance.  The program\ncan also take in two alignments and returns all helices potentially connecting\nthe two.";

const char *gengetopt_args_info_detailed_help[] = {
  "  -h, --help                   Print help and exit",
  "      --detailed-help          Print help, including all details and hidden\n                                 options, and exit",
  "      --full-help              Print help, including hidden options, and exit",
  "  -V, --version                Print version and exit",
  "  -a, --target=FILENAME        RNA multiple sequence alignment in FASTA format",
  "  -t, --tree=FILENAME          Phylogenetic tree in Newick format for the\n                                 alignment",
  "  -r, --shape=FILENAME         Shape file with reference sequence",
  "      --model=STRING           Path to folder with Models for DFG",
  "      --logdist=FILENAME       Shape file with reference sequence",
  "      --fso                    Choose candidates only from first sequence\n                                 (default=off)",
  "      --noNorm                 Do not normalize by sequence length\n                                 (default=off)",
  "      --mult=DOUBLE            Multiple value for Shape Log-Likelihoods\n                                 (default=`1.0')",
  "      --fc=DOUBLE              Factor value for Felsenstein part of Formula\n                                 (default=`1.0')",
  "      --fs=DOUBLE              Multiple value for Shape part of Formula\n                                 (default=`1.0')",
  "  -o, --output=PREFIX          Prefix of output files  (default=`helices')",
  "  -b, --query=FILENAME         Second multiple sequence alignment, triggers\n                                 interacting helix prediction",
  "  -s, --min_stem_length=INT    Minimum length of candidate helices to predict\n                                 (default=`3')",
  "  -l, --min_loop_length=INT    Minimum length of loops in candidate helices\n                                 (default=`2')",
  "  -p, --min_p_value=DOUBLE     Approximate minimum possible p-value, controls\n                                 number of random trials  (default=`0.001')",
  "  -0, --no-p-value             Skips p-value calculation, setting all p-values\n                                 to 0 (extremely fast)  (default=off)",
  "  -d, --dot-bracket            Enables bracket structure in the output\n                                 (increases output size)  (default=off)",
  "  -x, --p-value-max=DOUBLE     Does not output helices with p-values above this\n                                 value",
  "  Does not decrease runtime, simply decreases output filesize.",
  "  -y, --likelihood-min=DOUBLE  Does not output helices with log likelihoods\n                                 under this ratio",
  "  Does not decrease runtime, simply decreases output filesize.",
  "  -c, --target-codon=STRING    Supply a codon annotation of the input file",
  "  The annotation can only contain values: 0, 1, 2, 3 where 0 is non-coding and\n  1, 2 and 3 are the three codons positions for each codon.  START and STOP\n  codons should also be annotated with 123.  All guarantees are lost when\n  nonsense annotations are given.",
  "  -f, --subsample-pval         Reduces sampling size when calculating p-values,\n                                 reducing runtime  (default=off)",
  "  -e, --estimate-pval          Reduces sampling size and estimates a null\n                                 distribution for p-values  (default=off)",
  "  Implies subsample-pval.  Runtime slightly more than subsample-pval, but the\n  values generated are theoretically more accurate",
  "  -m, --mantissa               Uses a mantissa-based number type for\n                                 probability calculations  (default=off)",
  "  Prevents underflow for alignments with a large number of species, at the\n  expense of increased runtime. Typically not required unless log likelihood\n  values of the output look highly unusual (i.e. Inf, or 0)",
  "      --debug                  Set fixed random seed for exactly reproducible\n                                 results  (default=off)",
  "  -g, --no-gap-penalty         Removes the likelihood penalty placed on\n                                 one-sided gaps  (default=off)",
  "  -i, --interactions-only      Applicable only when target and query file are\n                                 given, returns only interacting helices\n                                 (default=off)",
  "      --likelihood_only        Prints matrix of paired likelihoods, and a list\n                                 of unpaired  instead of running Transat as\n                                 usual  (default=off)",
  "      --shuffle_only=INT       Shuffles alignment n times, writes files with\n                                 output prefix  (default=`0')",
  "      --read_helix=FILENAME    Reads in a predefined helix structure in helix\n                                 format",
  "      --tree_factor=DOUBLE     Rescale the tree by this factor",
  "      --no_cache               Turn off the log likelihood, trades speed for\n                                 (less) memory  (default=off)",
  "      --realign                Set realignment to be performed for shuffling\n                                 (default=off)",
  "      --no_normalize           Do not normalize log-likelihood by helix length\n                                 in basepairs  (default=off)",
  "      --indep_pvalues          Calculate pValues independently for A, B, and AB\n                                 helices  (default=off)",
  "  If set, three independent null distributions are created. By default, only\n  one null distribution containing cis and trans helices is used for pValue\n  calculation for A, B and AB helices",
  "      --subhelices             Include all subhelices  (default=off)",
  "      --first_seq_only         Choose candidates only from first sequence\n                                 (default=off)",
  "  -v, --verbose                Verbose debug output  (default=off)",
  "  Please check the README file for examples and output file format",
    0
};
static void
init_full_help_array(void)
{
  gengetopt_args_info_full_help[0] = gengetopt_args_info_detailed_help[0];
  gengetopt_args_info_full_help[1] = gengetopt_args_info_detailed_help[1];
  gengetopt_args_info_full_help[2] = gengetopt_args_info_detailed_help[2];
  gengetopt_args_info_full_help[3] = gengetopt_args_info_detailed_help[3];
  gengetopt_args_info_full_help[4] = gengetopt_args_info_detailed_help[4];
  gengetopt_args_info_full_help[5] = gengetopt_args_info_detailed_help[5];
  gengetopt_args_info_full_help[6] = gengetopt_args_info_detailed_help[6];
  gengetopt_args_info_full_help[7] = gengetopt_args_info_detailed_help[7];
  gengetopt_args_info_full_help[8] = gengetopt_args_info_detailed_help[8];
  gengetopt_args_info_full_help[9] = gengetopt_args_info_detailed_help[9];
  gengetopt_args_info_full_help[10] = gengetopt_args_info_detailed_help[10];
  gengetopt_args_info_full_help[11] = gengetopt_args_info_detailed_help[11];
  gengetopt_args_info_full_help[12] = gengetopt_args_info_detailed_help[12];
  gengetopt_args_info_full_help[13] = gengetopt_args_info_detailed_help[13];
  gengetopt_args_info_full_help[14] = gengetopt_args_info_detailed_help[14];
  gengetopt_args_info_full_help[15] = gengetopt_args_info_detailed_help[15];
  gengetopt_args_info_full_help[16] = gengetopt_args_info_detailed_help[16];
  gengetopt_args_info_full_help[17] = gengetopt_args_info_detailed_help[17];
  gengetopt_args_info_full_help[18] = gengetopt_args_info_detailed_help[18];
  gengetopt_args_info_full_help[19] = gengetopt_args_info_detailed_help[19];
  gengetopt_args_info_full_help[20] = gengetopt_args_info_detailed_help[20];
  gengetopt_args_info_full_help[21] = gengetopt_args_info_detailed_help[21];
  gengetopt_args_info_full_help[22] = gengetopt_args_info_detailed_help[23];
  gengetopt_args_info_full_help[23] = gengetopt_args_info_detailed_help[25];
  gengetopt_args_info_full_help[24] = gengetopt_args_info_detailed_help[27];
  gengetopt_args_info_full_help[25] = gengetopt_args_info_detailed_help[28];
  gengetopt_args_info_full_help[26] = gengetopt_args_info_detailed_help[30];
  gengetopt_args_info_full_help[27] = gengetopt_args_info_detailed_help[32];
  gengetopt_args_info_full_help[28] = gengetopt_args_info_detailed_help[33];
  gengetopt_args_info_full_help[29] = gengetopt_args_info_detailed_help[34];
  gengetopt_args_info_full_help[30] = gengetopt_args_info_detailed_help[35];
  gengetopt_args_info_full_help[31] = gengetopt_args_info_detailed_help[36];
  gengetopt_args_info_full_help[32] = gengetopt_args_info_detailed_help[37];
  gengetopt_args_info_full_help[33] = gengetopt_args_info_detailed_help[38];
  gengetopt_args_info_full_help[34] = gengetopt_args_info_detailed_help[39];
  gengetopt_args_info_full_help[35] = gengetopt_args_info_detailed_help[40];
  gengetopt_args_info_full_help[36] = gengetopt_args_info_detailed_help[41];
  gengetopt_args_info_full_help[37] = gengetopt_args_info_detailed_help[42];
  gengetopt_args_info_full_help[38] = gengetopt_args_info_detailed_help[44];
  gengetopt_args_info_full_help[39] = gengetopt_args_info_detailed_help[45];
  gengetopt_args_info_full_help[40] = gengetopt_args_info_detailed_help[46];
  gengetopt_args_info_full_help[41] = 0; 
  
}

const char *gengetopt_args_info_full_help[42];

static void
init_help_array(void)
{
  gengetopt_args_info_help[0] = gengetopt_args_info_detailed_help[0];
  gengetopt_args_info_help[1] = gengetopt_args_info_detailed_help[1];
  gengetopt_args_info_help[2] = gengetopt_args_info_detailed_help[2];
  gengetopt_args_info_help[3] = gengetopt_args_info_detailed_help[3];
  gengetopt_args_info_help[4] = gengetopt_args_info_detailed_help[4];
  gengetopt_args_info_help[5] = gengetopt_args_info_detailed_help[5];
  gengetopt_args_info_help[6] = gengetopt_args_info_detailed_help[6];
  gengetopt_args_info_help[7] = gengetopt_args_info_detailed_help[7];
  gengetopt_args_info_help[8] = gengetopt_args_info_detailed_help[8];
  gengetopt_args_info_help[9] = gengetopt_args_info_detailed_help[9];
  gengetopt_args_info_help[10] = gengetopt_args_info_detailed_help[10];
  gengetopt_args_info_help[11] = gengetopt_args_info_detailed_help[11];
  gengetopt_args_info_help[12] = gengetopt_args_info_detailed_help[12];
  gengetopt_args_info_help[13] = gengetopt_args_info_detailed_help[13];
  gengetopt_args_info_help[14] = gengetopt_args_info_detailed_help[14];
  gengetopt_args_info_help[15] = gengetopt_args_info_detailed_help[15];
  gengetopt_args_info_help[16] = gengetopt_args_info_detailed_help[16];
  gengetopt_args_info_help[17] = gengetopt_args_info_detailed_help[17];
  gengetopt_args_info_help[18] = gengetopt_args_info_detailed_help[18];
  gengetopt_args_info_help[19] = gengetopt_args_info_detailed_help[19];
  gengetopt_args_info_help[20] = gengetopt_args_info_detailed_help[20];
  gengetopt_args_info_help[21] = gengetopt_args_info_detailed_help[21];
  gengetopt_args_info_help[22] = gengetopt_args_info_detailed_help[23];
  gengetopt_args_info_help[23] = gengetopt_args_info_detailed_help[25];
  gengetopt_args_info_help[24] = gengetopt_args_info_detailed_help[27];
  gengetopt_args_info_help[25] = gengetopt_args_info_detailed_help[28];
  gengetopt_args_info_help[26] = gengetopt_args_info_detailed_help[30];
  gengetopt_args_info_help[27] = gengetopt_args_info_detailed_help[33];
  gengetopt_args_info_help[28] = gengetopt_args_info_detailed_help[34];
  gengetopt_args_info_help[29] = gengetopt_args_info_detailed_help[46];
  gengetopt_args_info_help[30] = 0; 
  
}

const char *gengetopt_args_info_help[31];

typedef enum {ARG_NO
  , ARG_FLAG
  , ARG_STRING
  , ARG_INT
  , ARG_DOUBLE
} cmdline_parser_arg_type;

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char **argv, struct gengetopt_args_info *args_info,
                        struct cmdline_parser_params *params, const char *additional_error);

static int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error);

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->detailed_help_given = 0 ;
  args_info->full_help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->target_given = 0 ;
  args_info->tree_given = 0 ;
  args_info->shape_given = 0 ;
  args_info->model_given = 0 ;
  args_info->logdist_given = 0 ;
  args_info->fso_given = 0 ;
  args_info->noNorm_given = 0 ;
  args_info->mult_given = 0 ;
  args_info->fc_given = 0 ;
  args_info->fs_given = 0 ;
  args_info->output_given = 0 ;
  args_info->query_given = 0 ;
  args_info->min_stem_length_given = 0 ;
  args_info->min_loop_length_given = 0 ;
  args_info->min_p_value_given = 0 ;
  args_info->no_p_value_given = 0 ;
  args_info->dot_bracket_given = 0 ;
  args_info->p_value_max_given = 0 ;
  args_info->likelihood_min_given = 0 ;
  args_info->target_codon_given = 0 ;
  args_info->subsample_pval_given = 0 ;
  args_info->estimate_pval_given = 0 ;
  args_info->mantissa_given = 0 ;
  args_info->debug_given = 0 ;
  args_info->no_gap_penalty_given = 0 ;
  args_info->interactions_only_given = 0 ;
  args_info->likelihood_only_given = 0 ;
  args_info->shuffle_only_given = 0 ;
  args_info->read_helix_given = 0 ;
  args_info->tree_factor_given = 0 ;
  args_info->no_cache_given = 0 ;
  args_info->realign_given = 0 ;
  args_info->no_normalize_given = 0 ;
  args_info->indep_pvalues_given = 0 ;
  args_info->subhelices_given = 0 ;
  args_info->first_seq_only_given = 0 ;
  args_info->verbose_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  FIX_UNUSED (args_info);
  args_info->target_arg = NULL;
  args_info->target_orig = NULL;
  args_info->tree_arg = NULL;
  args_info->tree_orig = NULL;
  args_info->shape_arg = NULL;
  args_info->shape_orig = NULL;
  args_info->model_arg = NULL;
  args_info->model_orig = NULL;
  args_info->logdist_arg = NULL;
  args_info->logdist_orig = NULL;
  args_info->fso_flag = 0;
  args_info->noNorm_flag = 0;
  args_info->mult_arg = 1.0;
  args_info->mult_orig = NULL;
  args_info->fc_arg = 1.0;
  args_info->fc_orig = NULL;
  args_info->fs_arg = 1.0;
  args_info->fs_orig = NULL;
  args_info->output_arg = gengetopt_strdup ("helices");
  args_info->output_orig = NULL;
  args_info->query_arg = NULL;
  args_info->query_orig = NULL;
  args_info->min_stem_length_arg = 3;
  args_info->min_stem_length_orig = NULL;
  args_info->min_loop_length_arg = 2;
  args_info->min_loop_length_orig = NULL;
  args_info->min_p_value_arg = 0.001;
  args_info->min_p_value_orig = NULL;
  args_info->no_p_value_flag = 0;
  args_info->dot_bracket_flag = 0;
  args_info->p_value_max_orig = NULL;
  args_info->likelihood_min_orig = NULL;
  args_info->target_codon_arg = NULL;
  args_info->target_codon_orig = NULL;
  args_info->subsample_pval_flag = 0;
  args_info->estimate_pval_flag = 0;
  args_info->mantissa_flag = 0;
  args_info->debug_flag = 0;
  args_info->no_gap_penalty_flag = 0;
  args_info->interactions_only_flag = 0;
  args_info->likelihood_only_flag = 0;
  args_info->shuffle_only_arg = 0;
  args_info->shuffle_only_orig = NULL;
  args_info->read_helix_arg = NULL;
  args_info->read_helix_orig = NULL;
  args_info->tree_factor_orig = NULL;
  args_info->no_cache_flag = 0;
  args_info->realign_flag = 0;
  args_info->no_normalize_flag = 0;
  args_info->indep_pvalues_flag = 0;
  args_info->subhelices_flag = 0;
  args_info->first_seq_only_flag = 0;
  args_info->verbose_flag = 0;
  
}

static
void init_args_info(struct gengetopt_args_info *args_info)
{
  init_full_help_array(); 
  init_help_array(); 
  args_info->help_help = gengetopt_args_info_detailed_help[0] ;
  args_info->detailed_help_help = gengetopt_args_info_detailed_help[1] ;
  args_info->full_help_help = gengetopt_args_info_detailed_help[2] ;
  args_info->version_help = gengetopt_args_info_detailed_help[3] ;
  args_info->target_help = gengetopt_args_info_detailed_help[4] ;
  args_info->tree_help = gengetopt_args_info_detailed_help[5] ;
  args_info->shape_help = gengetopt_args_info_detailed_help[6] ;
  args_info->model_help = gengetopt_args_info_detailed_help[7] ;
  args_info->logdist_help = gengetopt_args_info_detailed_help[8] ;
  args_info->fso_help = gengetopt_args_info_detailed_help[9] ;
  args_info->noNorm_help = gengetopt_args_info_detailed_help[10] ;
  args_info->mult_help = gengetopt_args_info_detailed_help[11] ;
  args_info->fc_help = gengetopt_args_info_detailed_help[12] ;
  args_info->fs_help = gengetopt_args_info_detailed_help[13] ;
  args_info->output_help = gengetopt_args_info_detailed_help[14] ;
  args_info->query_help = gengetopt_args_info_detailed_help[15] ;
  args_info->min_stem_length_help = gengetopt_args_info_detailed_help[16] ;
  args_info->min_loop_length_help = gengetopt_args_info_detailed_help[17] ;
  args_info->min_p_value_help = gengetopt_args_info_detailed_help[18] ;
  args_info->no_p_value_help = gengetopt_args_info_detailed_help[19] ;
  args_info->dot_bracket_help = gengetopt_args_info_detailed_help[20] ;
  args_info->p_value_max_help = gengetopt_args_info_detailed_help[21] ;
  args_info->likelihood_min_help = gengetopt_args_info_detailed_help[23] ;
  args_info->target_codon_help = gengetopt_args_info_detailed_help[25] ;
  args_info->subsample_pval_help = gengetopt_args_info_detailed_help[27] ;
  args_info->estimate_pval_help = gengetopt_args_info_detailed_help[28] ;
  args_info->mantissa_help = gengetopt_args_info_detailed_help[30] ;
  args_info->debug_help = gengetopt_args_info_detailed_help[32] ;
  args_info->no_gap_penalty_help = gengetopt_args_info_detailed_help[33] ;
  args_info->interactions_only_help = gengetopt_args_info_detailed_help[34] ;
  args_info->likelihood_only_help = gengetopt_args_info_detailed_help[35] ;
  args_info->shuffle_only_help = gengetopt_args_info_detailed_help[36] ;
  args_info->read_helix_help = gengetopt_args_info_detailed_help[37] ;
  args_info->tree_factor_help = gengetopt_args_info_detailed_help[38] ;
  args_info->no_cache_help = gengetopt_args_info_detailed_help[39] ;
  args_info->realign_help = gengetopt_args_info_detailed_help[40] ;
  args_info->no_normalize_help = gengetopt_args_info_detailed_help[41] ;
  args_info->indep_pvalues_help = gengetopt_args_info_detailed_help[42] ;
  args_info->subhelices_help = gengetopt_args_info_detailed_help[44] ;
  args_info->first_seq_only_help = gengetopt_args_info_detailed_help[45] ;
  args_info->verbose_help = gengetopt_args_info_detailed_help[46] ;
  
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n",
     (strlen(CMDLINE_PARSER_PACKAGE_NAME) ? CMDLINE_PARSER_PACKAGE_NAME : CMDLINE_PARSER_PACKAGE),
     CMDLINE_PARSER_VERSION);

  if (strlen(gengetopt_args_info_versiontext) > 0)
    printf("\n%s\n", gengetopt_args_info_versiontext);
}

static void print_help_common(void) {
  cmdline_parser_print_version ();

  if (strlen(gengetopt_args_info_purpose) > 0)
    printf("\n%s\n", gengetopt_args_info_purpose);

  if (strlen(gengetopt_args_info_usage) > 0)
    printf("\n%s\n", gengetopt_args_info_usage);

  printf("\n");

  if (strlen(gengetopt_args_info_description) > 0)
    printf("%s\n\n", gengetopt_args_info_description);
}

void
cmdline_parser_print_help (void)
{
  int i = 0;
  print_help_common();
  while (gengetopt_args_info_help[i])
    printf("%s\n", gengetopt_args_info_help[i++]);
}

void
cmdline_parser_print_full_help (void)
{
  int i = 0;
  print_help_common();
  while (gengetopt_args_info_full_help[i])
    printf("%s\n", gengetopt_args_info_full_help[i++]);
}

void
cmdline_parser_print_detailed_help (void)
{
  int i = 0;
  print_help_common();
  while (gengetopt_args_info_detailed_help[i])
    printf("%s\n", gengetopt_args_info_detailed_help[i++]);
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
  init_args_info (args_info);
}

void
cmdline_parser_params_init(struct cmdline_parser_params *params)
{
  if (params)
    { 
      params->override = 0;
      params->initialize = 1;
      params->check_required = 1;
      params->check_ambiguity = 0;
      params->print_errors = 1;
    }
}

struct cmdline_parser_params *
cmdline_parser_params_create(void)
{
  struct cmdline_parser_params *params = 
    (struct cmdline_parser_params *)malloc(sizeof(struct cmdline_parser_params));
  cmdline_parser_params_init(params);  
  return params;
}

static void
free_string_field (char **s)
{
  if (*s)
    {
      free (*s);
      *s = 0;
    }
}


static void
cmdline_parser_release (struct gengetopt_args_info *args_info)
{

  free_string_field (&(args_info->target_arg));
  free_string_field (&(args_info->target_orig));
  free_string_field (&(args_info->tree_arg));
  free_string_field (&(args_info->tree_orig));
  free_string_field (&(args_info->shape_arg));
  free_string_field (&(args_info->shape_orig));
  free_string_field (&(args_info->model_arg));
  free_string_field (&(args_info->model_orig));
  free_string_field (&(args_info->logdist_arg));
  free_string_field (&(args_info->logdist_orig));
  free_string_field (&(args_info->mult_orig));
  free_string_field (&(args_info->fc_orig));
  free_string_field (&(args_info->fs_orig));
  free_string_field (&(args_info->output_arg));
  free_string_field (&(args_info->output_orig));
  free_string_field (&(args_info->query_arg));
  free_string_field (&(args_info->query_orig));
  free_string_field (&(args_info->min_stem_length_orig));
  free_string_field (&(args_info->min_loop_length_orig));
  free_string_field (&(args_info->min_p_value_orig));
  free_string_field (&(args_info->p_value_max_orig));
  free_string_field (&(args_info->likelihood_min_orig));
  free_string_field (&(args_info->target_codon_arg));
  free_string_field (&(args_info->target_codon_orig));
  free_string_field (&(args_info->shuffle_only_orig));
  free_string_field (&(args_info->read_helix_arg));
  free_string_field (&(args_info->read_helix_orig));
  free_string_field (&(args_info->tree_factor_orig));
  
  

  clear_given (args_info);
}


static void
write_into_file(FILE *outfile, const char *opt, const char *arg, const char *values[])
{
  FIX_UNUSED (values);
  if (arg) {
    fprintf(outfile, "%s=\"%s\"\n", opt, arg);
  } else {
    fprintf(outfile, "%s\n", opt);
  }
}


int
cmdline_parser_dump(FILE *outfile, struct gengetopt_args_info *args_info)
{
  int i = 0;

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot dump options to stream\n", CMDLINE_PARSER_PACKAGE);
      return EXIT_FAILURE;
    }

  if (args_info->help_given)
    write_into_file(outfile, "help", 0, 0 );
  if (args_info->detailed_help_given)
    write_into_file(outfile, "detailed-help", 0, 0 );
  if (args_info->full_help_given)
    write_into_file(outfile, "full-help", 0, 0 );
  if (args_info->version_given)
    write_into_file(outfile, "version", 0, 0 );
  if (args_info->target_given)
    write_into_file(outfile, "target", args_info->target_orig, 0);
  if (args_info->tree_given)
    write_into_file(outfile, "tree", args_info->tree_orig, 0);
  if (args_info->shape_given)
    write_into_file(outfile, "shape", args_info->shape_orig, 0);
  if (args_info->model_given)
    write_into_file(outfile, "model", args_info->model_orig, 0);
  if (args_info->logdist_given)
    write_into_file(outfile, "logdist", args_info->logdist_orig, 0);
  if (args_info->fso_given)
    write_into_file(outfile, "fso", 0, 0 );
  if (args_info->noNorm_given)
    write_into_file(outfile, "noNorm", 0, 0 );
  if (args_info->mult_given)
    write_into_file(outfile, "mult", args_info->mult_orig, 0);
  if (args_info->fc_given)
    write_into_file(outfile, "fc", args_info->fc_orig, 0);
  if (args_info->fs_given)
    write_into_file(outfile, "fs", args_info->fs_orig, 0);
  if (args_info->output_given)
    write_into_file(outfile, "output", args_info->output_orig, 0);
  if (args_info->query_given)
    write_into_file(outfile, "query", args_info->query_orig, 0);
  if (args_info->min_stem_length_given)
    write_into_file(outfile, "min_stem_length", args_info->min_stem_length_orig, 0);
  if (args_info->min_loop_length_given)
    write_into_file(outfile, "min_loop_length", args_info->min_loop_length_orig, 0);
  if (args_info->min_p_value_given)
    write_into_file(outfile, "min_p_value", args_info->min_p_value_orig, 0);
  if (args_info->no_p_value_given)
    write_into_file(outfile, "no-p-value", 0, 0 );
  if (args_info->dot_bracket_given)
    write_into_file(outfile, "dot-bracket", 0, 0 );
  if (args_info->p_value_max_given)
    write_into_file(outfile, "p-value-max", args_info->p_value_max_orig, 0);
  if (args_info->likelihood_min_given)
    write_into_file(outfile, "likelihood-min", args_info->likelihood_min_orig, 0);
  if (args_info->target_codon_given)
    write_into_file(outfile, "target-codon", args_info->target_codon_orig, 0);
  if (args_info->subsample_pval_given)
    write_into_file(outfile, "subsample-pval", 0, 0 );
  if (args_info->estimate_pval_given)
    write_into_file(outfile, "estimate-pval", 0, 0 );
  if (args_info->mantissa_given)
    write_into_file(outfile, "mantissa", 0, 0 );
  if (args_info->debug_given)
    write_into_file(outfile, "debug", 0, 0 );
  if (args_info->no_gap_penalty_given)
    write_into_file(outfile, "no-gap-penalty", 0, 0 );
  if (args_info->interactions_only_given)
    write_into_file(outfile, "interactions-only", 0, 0 );
  if (args_info->likelihood_only_given)
    write_into_file(outfile, "likelihood_only", 0, 0 );
  if (args_info->shuffle_only_given)
    write_into_file(outfile, "shuffle_only", args_info->shuffle_only_orig, 0);
  if (args_info->read_helix_given)
    write_into_file(outfile, "read_helix", args_info->read_helix_orig, 0);
  if (args_info->tree_factor_given)
    write_into_file(outfile, "tree_factor", args_info->tree_factor_orig, 0);
  if (args_info->no_cache_given)
    write_into_file(outfile, "no_cache", 0, 0 );
  if (args_info->realign_given)
    write_into_file(outfile, "realign", 0, 0 );
  if (args_info->no_normalize_given)
    write_into_file(outfile, "no_normalize", 0, 0 );
  if (args_info->indep_pvalues_given)
    write_into_file(outfile, "indep_pvalues", 0, 0 );
  if (args_info->subhelices_given)
    write_into_file(outfile, "subhelices", 0, 0 );
  if (args_info->first_seq_only_given)
    write_into_file(outfile, "first_seq_only", 0, 0 );
  if (args_info->verbose_given)
    write_into_file(outfile, "verbose", 0, 0 );
  

  i = EXIT_SUCCESS;
  return i;
}

int
cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  i = cmdline_parser_dump(outfile, args_info);
  fclose (outfile);

  return i;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  cmdline_parser_release (args_info);
}

/** @brief replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = 0;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char **argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser_ext (int argc, char **argv, struct gengetopt_args_info *args_info,
                   struct cmdline_parser_params *params)
{
  int result;
  result = cmdline_parser_internal (argc, argv, args_info, params, 0);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser2 (int argc, char **argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;
  struct cmdline_parser_params params;
  
  params.override = override;
  params.initialize = initialize;
  params.check_required = check_required;
  params.check_ambiguity = 0;
  params.print_errors = 1;

  result = cmdline_parser_internal (argc, argv, args_info, &params, 0);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name)
{
  int result = EXIT_SUCCESS;

  if (cmdline_parser_required2(args_info, prog_name, 0) > 0)
    result = EXIT_FAILURE;

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error)
{
  int error_occurred = 0;
  FIX_UNUSED (additional_error);

  /* checks for required options */
  if (! args_info->target_given)
    {
      fprintf (stderr, "%s: '--target' ('-a') option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error_occurred = 1;
    }
  
  if (! args_info->tree_given)
    {
      fprintf (stderr, "%s: '--tree' ('-t') option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error_occurred = 1;
    }
  
  if (! args_info->shape_given)
    {
      fprintf (stderr, "%s: '--shape' ('-r') option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error_occurred = 1;
    }
  
  if (! args_info->model_given)
    {
      fprintf (stderr, "%s: '--model' option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error_occurred = 1;
    }
  
  if (! args_info->logdist_given)
    {
      fprintf (stderr, "%s: '--logdist' option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error_occurred = 1;
    }
  
  if (! args_info->mult_given)
    {
      fprintf (stderr, "%s: '--mult' option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error_occurred = 1;
    }
  
  if (! args_info->fc_given)
    {
      fprintf (stderr, "%s: '--fc' option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error_occurred = 1;
    }
  
  if (! args_info->fs_given)
    {
      fprintf (stderr, "%s: '--fs' option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error_occurred = 1;
    }
  
  if (! args_info->min_stem_length_given)
    {
      fprintf (stderr, "%s: '--min_stem_length' ('-s') option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error_occurred = 1;
    }
  
  if (! args_info->min_loop_length_given)
    {
      fprintf (stderr, "%s: '--min_loop_length' ('-l') option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error_occurred = 1;
    }
  
  if (! args_info->min_p_value_given)
    {
      fprintf (stderr, "%s: '--min_p_value' ('-p') option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error_occurred = 1;
    }
  
  
  /* checks for dependences among options */

  return error_occurred;
}


static char *package_name = 0;

/**
 * @brief updates an option
 * @param field the generic pointer to the field to update
 * @param orig_field the pointer to the orig field
 * @param field_given the pointer to the number of occurrence of this option
 * @param prev_given the pointer to the number of occurrence already seen
 * @param value the argument for this option (if null no arg was specified)
 * @param possible_values the possible values for this option (if specified)
 * @param default_value the default value (in case the option only accepts fixed values)
 * @param arg_type the type of this option
 * @param check_ambiguity @see cmdline_parser_params.check_ambiguity
 * @param override @see cmdline_parser_params.override
 * @param no_free whether to free a possible previous value
 * @param multiple_option whether this is a multiple option
 * @param long_opt the corresponding long option
 * @param short_opt the corresponding short option (or '-' if none)
 * @param additional_error possible further error specification
 */
static
int update_arg(void *field, char **orig_field,
               unsigned int *field_given, unsigned int *prev_given, 
               char *value, const char *possible_values[],
               const char *default_value,
               cmdline_parser_arg_type arg_type,
               int check_ambiguity, int override,
               int no_free, int multiple_option,
               const char *long_opt, char short_opt,
               const char *additional_error)
{
  char *stop_char = 0;
  const char *val = value;
  int found;
  char **string_field;
  FIX_UNUSED (field);

  stop_char = 0;
  found = 0;

  if (!multiple_option && prev_given && (*prev_given || (check_ambiguity && *field_given)))
    {
      if (short_opt != '-')
        fprintf (stderr, "%s: `--%s' (`-%c') option given more than once%s\n", 
               package_name, long_opt, short_opt,
               (additional_error ? additional_error : ""));
      else
        fprintf (stderr, "%s: `--%s' option given more than once%s\n", 
               package_name, long_opt,
               (additional_error ? additional_error : ""));
      return 1; /* failure */
    }

  FIX_UNUSED (default_value);
    
  if (field_given && *field_given && ! override)
    return 0;
  if (prev_given)
    (*prev_given)++;
  if (field_given)
    (*field_given)++;
  if (possible_values)
    val = possible_values[found];

  switch(arg_type) {
  case ARG_FLAG:
    *((int *)field) = !*((int *)field);
    break;
  case ARG_INT:
    if (val) *((int *)field) = strtol (val, &stop_char, 0);
    break;
  case ARG_DOUBLE:
    if (val) *((double *)field) = strtod (val, &stop_char);
    break;
  case ARG_STRING:
    if (val) {
      string_field = (char **)field;
      if (!no_free && *string_field)
        free (*string_field); /* free previous string */
      *string_field = gengetopt_strdup (val);
    }
    break;
  default:
    break;
  };

  /* check numeric conversion */
  switch(arg_type) {
  case ARG_INT:
  case ARG_DOUBLE:
    if (val && !(stop_char && *stop_char == '\0')) {
      fprintf(stderr, "%s: invalid numeric value: %s\n", package_name, val);
      return 1; /* failure */
    }
    break;
  default:
    ;
  };

  /* store the original value */
  switch(arg_type) {
  case ARG_NO:
  case ARG_FLAG:
    break;
  default:
    if (value && orig_field) {
      if (no_free) {
        *orig_field = value;
      } else {
        if (*orig_field)
          free (*orig_field); /* free previous string */
        *orig_field = gengetopt_strdup (value);
      }
    }
  };

  return 0; /* OK */
}


int
cmdline_parser_internal (
  int argc, char **argv, struct gengetopt_args_info *args_info,
                        struct cmdline_parser_params *params, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error_occurred = 0;
  struct gengetopt_args_info local_args_info;
  
  int override;
  int initialize;
  int check_required;
  int check_ambiguity;
  
  package_name = argv[0];
  
  override = params->override;
  initialize = params->initialize;
  check_required = params->check_required;
  check_ambiguity = params->check_ambiguity;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 0;
  opterr = params->print_errors;
  optopt = '?';

  while (1)
    {
      int option_index = 0;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "detailed-help",	0, NULL, 0 },
        { "full-help",	0, NULL, 0 },
        { "version",	0, NULL, 'V' },
        { "target",	1, NULL, 'a' },
        { "tree",	1, NULL, 't' },
        { "shape",	1, NULL, 'r' },
        { "model",	1, NULL, 0 },
        { "logdist",	1, NULL, 0 },
        { "fso",	0, NULL, 0 },
        { "noNorm",	0, NULL, 0 },
        { "mult",	1, NULL, 0 },
        { "fc",	1, NULL, 0 },
        { "fs",	1, NULL, 0 },
        { "output",	1, NULL, 'o' },
        { "query",	1, NULL, 'b' },
        { "min_stem_length",	1, NULL, 's' },
        { "min_loop_length",	1, NULL, 'l' },
        { "min_p_value",	1, NULL, 'p' },
        { "no-p-value",	0, NULL, '0' },
        { "dot-bracket",	0, NULL, 'd' },
        { "p-value-max",	1, NULL, 'x' },
        { "likelihood-min",	1, NULL, 'y' },
        { "target-codon",	1, NULL, 'c' },
        { "subsample-pval",	0, NULL, 'f' },
        { "estimate-pval",	0, NULL, 'e' },
        { "mantissa",	0, NULL, 'm' },
        { "debug",	0, NULL, 0 },
        { "no-gap-penalty",	0, NULL, 'g' },
        { "interactions-only",	0, NULL, 'i' },
        { "likelihood_only",	0, NULL, 0 },
        { "shuffle_only",	1, NULL, 0 },
        { "read_helix",	1, NULL, 0 },
        { "tree_factor",	1, NULL, 0 },
        { "no_cache",	0, NULL, 0 },
        { "realign",	0, NULL, 0 },
        { "no_normalize",	0, NULL, 0 },
        { "indep_pvalues",	0, NULL, 0 },
        { "subhelices",	0, NULL, 0 },
        { "first_seq_only",	0, NULL, 0 },
        { "verbose",	0, NULL, 'v' },
        { 0,  0, 0, 0 }
      };

      c = getopt_long (argc, argv, "hVa:t:r:o:b:s:l:p:0dx:y:c:femgiv", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          cmdline_parser_print_version ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'a':	/* RNA multiple sequence alignment in FASTA format.  */
        
        
          if (update_arg( (void *)&(args_info->target_arg), 
               &(args_info->target_orig), &(args_info->target_given),
              &(local_args_info.target_given), optarg, 0, 0, ARG_STRING,
              check_ambiguity, override, 0, 0,
              "target", 'a',
              additional_error))
            goto failure;
        
          break;
        case 't':	/* Phylogenetic tree in Newick format for the alignment.  */
        
        
          if (update_arg( (void *)&(args_info->tree_arg), 
               &(args_info->tree_orig), &(args_info->tree_given),
              &(local_args_info.tree_given), optarg, 0, 0, ARG_STRING,
              check_ambiguity, override, 0, 0,
              "tree", 't',
              additional_error))
            goto failure;
        
          break;
        case 'r':	/* Shape file with reference sequence.  */
        
        
          if (update_arg( (void *)&(args_info->shape_arg), 
               &(args_info->shape_orig), &(args_info->shape_given),
              &(local_args_info.shape_given), optarg, 0, 0, ARG_STRING,
              check_ambiguity, override, 0, 0,
              "shape", 'r',
              additional_error))
            goto failure;
        
          break;
        case 'o':	/* Prefix of output files.  */
        
        
          if (update_arg( (void *)&(args_info->output_arg), 
               &(args_info->output_orig), &(args_info->output_given),
              &(local_args_info.output_given), optarg, 0, "helices", ARG_STRING,
              check_ambiguity, override, 0, 0,
              "output", 'o',
              additional_error))
            goto failure;
        
          break;
        case 'b':	/* Second multiple sequence alignment, triggers interacting helix prediction.  */
        
        
          if (update_arg( (void *)&(args_info->query_arg), 
               &(args_info->query_orig), &(args_info->query_given),
              &(local_args_info.query_given), optarg, 0, 0, ARG_STRING,
              check_ambiguity, override, 0, 0,
              "query", 'b',
              additional_error))
            goto failure;
        
          break;
        case 's':	/* Minimum length of candidate helices to predict.  */
        
        
          if (update_arg( (void *)&(args_info->min_stem_length_arg), 
               &(args_info->min_stem_length_orig), &(args_info->min_stem_length_given),
              &(local_args_info.min_stem_length_given), optarg, 0, "3", ARG_INT,
              check_ambiguity, override, 0, 0,
              "min_stem_length", 's',
              additional_error))
            goto failure;
        
          break;
        case 'l':	/* Minimum length of loops in candidate helices.  */
        
        
          if (update_arg( (void *)&(args_info->min_loop_length_arg), 
               &(args_info->min_loop_length_orig), &(args_info->min_loop_length_given),
              &(local_args_info.min_loop_length_given), optarg, 0, "2", ARG_INT,
              check_ambiguity, override, 0, 0,
              "min_loop_length", 'l',
              additional_error))
            goto failure;
        
          break;
        case 'p':	/* Approximate minimum possible p-value, controls number of random trials.  */
        
        
          if (update_arg( (void *)&(args_info->min_p_value_arg), 
               &(args_info->min_p_value_orig), &(args_info->min_p_value_given),
              &(local_args_info.min_p_value_given), optarg, 0, "0.001", ARG_DOUBLE,
              check_ambiguity, override, 0, 0,
              "min_p_value", 'p',
              additional_error))
            goto failure;
        
          break;
        case '0':	/* Skips p-value calculation, setting all p-values to 0 (extremely fast).  */
        
        
          if (update_arg((void *)&(args_info->no_p_value_flag), 0, &(args_info->no_p_value_given),
              &(local_args_info.no_p_value_given), optarg, 0, 0, ARG_FLAG,
              check_ambiguity, override, 1, 0, "no-p-value", '0',
              additional_error))
            goto failure;
        
          break;
        case 'd':	/* Enables bracket structure in the output (increases output size).  */
        
        
          if (update_arg((void *)&(args_info->dot_bracket_flag), 0, &(args_info->dot_bracket_given),
              &(local_args_info.dot_bracket_given), optarg, 0, 0, ARG_FLAG,
              check_ambiguity, override, 1, 0, "dot-bracket", 'd',
              additional_error))
            goto failure;
        
          break;
        case 'x':	/* Does not output helices with p-values above this value.  */
        
        
          if (update_arg( (void *)&(args_info->p_value_max_arg), 
               &(args_info->p_value_max_orig), &(args_info->p_value_max_given),
              &(local_args_info.p_value_max_given), optarg, 0, 0, ARG_DOUBLE,
              check_ambiguity, override, 0, 0,
              "p-value-max", 'x',
              additional_error))
            goto failure;
        
          break;
        case 'y':	/* Does not output helices with log likelihoods under this ratio.  */
        
        
          if (update_arg( (void *)&(args_info->likelihood_min_arg), 
               &(args_info->likelihood_min_orig), &(args_info->likelihood_min_given),
              &(local_args_info.likelihood_min_given), optarg, 0, 0, ARG_DOUBLE,
              check_ambiguity, override, 0, 0,
              "likelihood-min", 'y',
              additional_error))
            goto failure;
        
          break;
        case 'c':	/* Supply a codon annotation of the input file.  */
        
        
          if (update_arg( (void *)&(args_info->target_codon_arg), 
               &(args_info->target_codon_orig), &(args_info->target_codon_given),
              &(local_args_info.target_codon_given), optarg, 0, 0, ARG_STRING,
              check_ambiguity, override, 0, 0,
              "target-codon", 'c',
              additional_error))
            goto failure;
        
          break;
        case 'f':	/* Reduces sampling size when calculating p-values, reducing runtime.  */
        
        
          if (update_arg((void *)&(args_info->subsample_pval_flag), 0, &(args_info->subsample_pval_given),
              &(local_args_info.subsample_pval_given), optarg, 0, 0, ARG_FLAG,
              check_ambiguity, override, 1, 0, "subsample-pval", 'f',
              additional_error))
            goto failure;
        
          break;
        case 'e':	/* Reduces sampling size and estimates a null distribution for p-values.  */
        
        
          if (update_arg((void *)&(args_info->estimate_pval_flag), 0, &(args_info->estimate_pval_given),
              &(local_args_info.estimate_pval_given), optarg, 0, 0, ARG_FLAG,
              check_ambiguity, override, 1, 0, "estimate-pval", 'e',
              additional_error))
            goto failure;
        
          break;
        case 'm':	/* Uses a mantissa-based number type for probability calculations.  */
        
        
          if (update_arg((void *)&(args_info->mantissa_flag), 0, &(args_info->mantissa_given),
              &(local_args_info.mantissa_given), optarg, 0, 0, ARG_FLAG,
              check_ambiguity, override, 1, 0, "mantissa", 'm',
              additional_error))
            goto failure;
        
          break;
        case 'g':	/* Removes the likelihood penalty placed on one-sided gaps.  */
        
        
          if (update_arg((void *)&(args_info->no_gap_penalty_flag), 0, &(args_info->no_gap_penalty_given),
              &(local_args_info.no_gap_penalty_given), optarg, 0, 0, ARG_FLAG,
              check_ambiguity, override, 1, 0, "no-gap-penalty", 'g',
              additional_error))
            goto failure;
        
          break;
        case 'i':	/* Applicable only when target and query file are given, returns only interacting helices.  */
        
        
          if (update_arg((void *)&(args_info->interactions_only_flag), 0, &(args_info->interactions_only_given),
              &(local_args_info.interactions_only_given), optarg, 0, 0, ARG_FLAG,
              check_ambiguity, override, 1, 0, "interactions-only", 'i',
              additional_error))
            goto failure;
        
          break;
        case 'v':	/* Verbose debug output.  */
        
        
          if (update_arg((void *)&(args_info->verbose_flag), 0, &(args_info->verbose_given),
              &(local_args_info.verbose_given), optarg, 0, 0, ARG_FLAG,
              check_ambiguity, override, 1, 0, "verbose", 'v',
              additional_error))
            goto failure;
        
          break;

        case 0:	/* Long option with no short option */
          if (strcmp (long_options[option_index].name, "detailed-help") == 0) {
            cmdline_parser_print_detailed_help ();
            cmdline_parser_free (&local_args_info);
            exit (EXIT_SUCCESS);
          }

          if (strcmp (long_options[option_index].name, "full-help") == 0) {
            cmdline_parser_print_full_help ();
            cmdline_parser_free (&local_args_info);
            exit (EXIT_SUCCESS);
          }

          /* Path to folder with Models for DFG.  */
          if (strcmp (long_options[option_index].name, "model") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->model_arg), 
                 &(args_info->model_orig), &(args_info->model_given),
                &(local_args_info.model_given), optarg, 0, 0, ARG_STRING,
                check_ambiguity, override, 0, 0,
                "model", '-',
                additional_error))
              goto failure;
          
          }
          /* Shape file with reference sequence.  */
          else if (strcmp (long_options[option_index].name, "logdist") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->logdist_arg), 
                 &(args_info->logdist_orig), &(args_info->logdist_given),
                &(local_args_info.logdist_given), optarg, 0, 0, ARG_STRING,
                check_ambiguity, override, 0, 0,
                "logdist", '-',
                additional_error))
              goto failure;
          
          }
          /* Choose candidates only from first sequence.  */
          else if (strcmp (long_options[option_index].name, "fso") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->fso_flag), 0, &(args_info->fso_given),
                &(local_args_info.fso_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "fso", '-',
                additional_error))
              goto failure;
          
          }
          /* Do not normalize by sequence length.  */
          else if (strcmp (long_options[option_index].name, "noNorm") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->noNorm_flag), 0, &(args_info->noNorm_given),
                &(local_args_info.noNorm_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "noNorm", '-',
                additional_error))
              goto failure;
          
          }
          /* Multiple value for Shape Log-Likelihoods.  */
          else if (strcmp (long_options[option_index].name, "mult") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->mult_arg), 
                 &(args_info->mult_orig), &(args_info->mult_given),
                &(local_args_info.mult_given), optarg, 0, "1.0", ARG_DOUBLE,
                check_ambiguity, override, 0, 0,
                "mult", '-',
                additional_error))
              goto failure;
          
          }
          /* Factor value for Felsenstein part of Formula.  */
          else if (strcmp (long_options[option_index].name, "fc") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->fc_arg), 
                 &(args_info->fc_orig), &(args_info->fc_given),
                &(local_args_info.fc_given), optarg, 0, "1.0", ARG_DOUBLE,
                check_ambiguity, override, 0, 0,
                "fc", '-',
                additional_error))
              goto failure;
          
          }
          /* Multiple value for Shape part of Formula.  */
          else if (strcmp (long_options[option_index].name, "fs") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->fs_arg), 
                 &(args_info->fs_orig), &(args_info->fs_given),
                &(local_args_info.fs_given), optarg, 0, "1.0", ARG_DOUBLE,
                check_ambiguity, override, 0, 0,
                "fs", '-',
                additional_error))
              goto failure;
          
          }
          /* Set fixed random seed for exactly reproducible results.  */
          else if (strcmp (long_options[option_index].name, "debug") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->debug_flag), 0, &(args_info->debug_given),
                &(local_args_info.debug_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "debug", '-',
                additional_error))
              goto failure;
          
          }
          /* Prints matrix of paired likelihoods, and a list of unpaired  instead of running Transat as usual.  */
          else if (strcmp (long_options[option_index].name, "likelihood_only") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->likelihood_only_flag), 0, &(args_info->likelihood_only_given),
                &(local_args_info.likelihood_only_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "likelihood_only", '-',
                additional_error))
              goto failure;
          
          }
          /* Shuffles alignment n times, writes files with output prefix.  */
          else if (strcmp (long_options[option_index].name, "shuffle_only") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->shuffle_only_arg), 
                 &(args_info->shuffle_only_orig), &(args_info->shuffle_only_given),
                &(local_args_info.shuffle_only_given), optarg, 0, "0", ARG_INT,
                check_ambiguity, override, 0, 0,
                "shuffle_only", '-',
                additional_error))
              goto failure;
          
          }
          /* Reads in a predefined helix structure in helix format.  */
          else if (strcmp (long_options[option_index].name, "read_helix") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->read_helix_arg), 
                 &(args_info->read_helix_orig), &(args_info->read_helix_given),
                &(local_args_info.read_helix_given), optarg, 0, 0, ARG_STRING,
                check_ambiguity, override, 0, 0,
                "read_helix", '-',
                additional_error))
              goto failure;
          
          }
          /* Rescale the tree by this factor.  */
          else if (strcmp (long_options[option_index].name, "tree_factor") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->tree_factor_arg), 
                 &(args_info->tree_factor_orig), &(args_info->tree_factor_given),
                &(local_args_info.tree_factor_given), optarg, 0, 0, ARG_DOUBLE,
                check_ambiguity, override, 0, 0,
                "tree_factor", '-',
                additional_error))
              goto failure;
          
          }
          /* Turn off the log likelihood, trades speed for (less) memory.  */
          else if (strcmp (long_options[option_index].name, "no_cache") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->no_cache_flag), 0, &(args_info->no_cache_given),
                &(local_args_info.no_cache_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "no_cache", '-',
                additional_error))
              goto failure;
          
          }
          /* Set realignment to be performed for shuffling.  */
          else if (strcmp (long_options[option_index].name, "realign") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->realign_flag), 0, &(args_info->realign_given),
                &(local_args_info.realign_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "realign", '-',
                additional_error))
              goto failure;
          
          }
          /* Do not normalize log-likelihood by helix length in basepairs.  */
          else if (strcmp (long_options[option_index].name, "no_normalize") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->no_normalize_flag), 0, &(args_info->no_normalize_given),
                &(local_args_info.no_normalize_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "no_normalize", '-',
                additional_error))
              goto failure;
          
          }
          /* Calculate pValues independently for A, B, and AB helices.  */
          else if (strcmp (long_options[option_index].name, "indep_pvalues") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->indep_pvalues_flag), 0, &(args_info->indep_pvalues_given),
                &(local_args_info.indep_pvalues_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "indep_pvalues", '-',
                additional_error))
              goto failure;
          
          }
          /* Include all subhelices.  */
          else if (strcmp (long_options[option_index].name, "subhelices") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->subhelices_flag), 0, &(args_info->subhelices_given),
                &(local_args_info.subhelices_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "subhelices", '-',
                additional_error))
              goto failure;
          
          }
          /* Choose candidates only from first sequence.  */
          else if (strcmp (long_options[option_index].name, "first_seq_only") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->first_seq_only_flag), 0, &(args_info->first_seq_only_given),
                &(local_args_info.first_seq_only_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "first_seq_only", '-',
                additional_error))
              goto failure;
          
          }
          
          break;
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */



  if (check_required)
    {
      error_occurred += cmdline_parser_required2 (args_info, argv[0], additional_error);
    }

  cmdline_parser_release (&local_args_info);

  if ( error_occurred )
    return (EXIT_FAILURE);

  return 0;

failure:
  
  cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
